PROGRAM_NAME='MainCode'
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/05/2006  AT: 09:00:25        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

dvTP = 10001:1:0

vdvLicenseVerifier = 32768:1:0

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

persistent char applicationID[50]

#warn 'DO NOT forget to set the License Key that is generated by the AMX Master License Manager Software'
persistent char LicenseKey[50] = 'YourLicenseKey'

volatile integer licenseVerified = 0


(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

#warn 'DO NOT forget to set the Application ID that is generated by the AMX Master License Manager Software'
applicationID = 'YourApplicationID'

define_module 'LicenseVerifier' mod1(vdvLicenseVerifier)


(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

button_event[dvTP, 100]
{
    push:
    {
	send_command dvTP, "'@AKB-;Enter License Key'"
    }
}

data_event[dvTP]
{
    string:
    {
	char buffer[100]

	buffer = data.text
	
	if(find_string(buffer, 'ABORT', 1) == 0)
	{
	    if(find_string(buffer, 'KEYB-', 1) > 0)
	    {
		remove_string(buffer, 'KEYB-', 1)
		LicenseKey = buffer
		send_command vdvLicenseVerifier, "'VERIFYLIC-', applicationID,',', LicenseKey"
	    }
	}
    }
}


data_event[dvTP]
{
    online:
    {
	if(licenseVerified)
	{
	    // I will now remove the system locked page, so user can use the system freely 
	    send_command dvTP, "'PAGE-MainPage'"
	}
	else 
	{
	    // I will now remove the system locked page, To prevent user from using the system 
	    send_command dvTP, "'PAGE-SystemLockedPage'"
	    send_command vdvLicenseVerifier, "'VERIFYLIC-', applicationID,',', LicenseKey"
	}
    }
}

data_event[vdvLicenseVerifier]
{
    online:
    {
	send_command vdvLicenseVerifier, "'?SERIALNUMBER'"
	send_command vdvLicenseVerifier, "'VERIFYLIC-', applicationID,',', LicenseKey"
    }
    string:
    {
	char buffer[100]
	char response[50]
	
	send_string 0, "'Received Response is: ', data.text"
	
	buffer = data.text
	
	response = remove_string(buffer, '-', 1)
	
	if(upper_string(response) == upper_string('LICVERIFIED-'))
	{
	    // now I will show the module activation message in case the module is not activated
	    licenseVerified = find_string(upper_string(buffer), 'YES', 1)
	    if(licenseVerified)
	    {
		// I will now remove the system locked page, so user can use the system freely 
		send_command dvTP, "'PAGE-MainPage'"
	    }
	    else 
	    {
		// I will now show the system locked page, To prevent user from using the system 
		send_command dvTP, "'PAGE-SystemLockedPage'"
	    }
	}
    }
}



(*****************************************************************)
(*                                                               *)
(*                      !!!! WARNING !!!!                        *)
(*                                                               *)
(* Due to differences in the underlying architecture of the      *)
(* X-Series masters, changing variables in the DEFINE_PROGRAM    *)
(* section of code can negatively impact program performance.    *)
(*                                                               *)
(* See Differences in DEFINE_PROGRAM Program Execution section *)
(* of the NX-Series Controllers WebConsole & Programming Guide   *)
(* for additional and alternate coding methodologies.            *)
(*****************************************************************)

DEFINE_PROGRAM

(*****************************************************************)
(*                       END OF PROGRAM                          *)
(*                                                               *)
(*         !!!  DO NOT PUT ANY CODE BELOW THIS COMMENT  !!!      *)
(*                                                               *)
(*****************************************************************)


